var fs = require('fs');
const HotUpdateBuilder = Editor.require('packages://gen-manifests/utils/HotUpdateBuilder.js');
var FsExtra = require("fs-extra");
var path = require('path');
var FsUtils = Editor.require('packages://gen-manifests/utils/FsUtils.js');
Editor.Panel.extend({
    style: fs.readFileSync(Editor.url('packages://gen-manifests/panel/index.css', 'utf8')) + "",
    template: fs.readFileSync(Editor.url('packages://gen-manifests/panel/index.html', 'utf8')) + "",

    ready() {
        this.vue = new window.Vue({
            el: this.shadowRoot,
            init: function() {},
            created: function() {},
            data: {
                buildType: "jsb-link",
                packageSaveDir: "build/MiniGame/",
                packageUrl: "http://127.0.0.1/Game",
                mainPackNoGen: [],
                mainManifest: {
                    name : "lobby",
                    version: '1.0.0',
                    assets: {},
                    searchPaths: []
                },
                subpackArr: []
            },

            methods: {
                changeDir(event) {
                    Editor.log(event);
                },
                addSubpack() {
                    this.subpackArr.push({
                        name: "Game ",
                        version: "0.0.1",
                        resDirs: [""],
                        assets: {},
                    });
                },
                delSubpack(index) {
                    if (confirm("Bạn có chắc chắn muốn xóa  " + this.subpackArr[index].name + "không ?") === true) {
                        this.subpackArr.splice(index, 1);
                    }
                },
                addResDir(pack) {
                    pack.resDirs.push("");
                },
                delResDir(pack, index) {
                    if (confirm("Bạn có chắc chắn muốn xóa không\n" + pack.resDirs[index]) === true) {
                        pack.resDirs.splice(index, 1);
                    }
                },
                onOpenDir(rPath) {
                    let fullpath = path.join(Editor.Project.path, rPath);
                    FsUtils.openDir(fullpath);

                },
                onSelectSubResDir(resDirs, index) {
                    var dir = FsUtils.selectDir();
                    dir = FsUtils.getRelativePath(dir);

                    resDirs.splice(index, 1, dir);
                },
                buildSubpack() {
                    var self = this;
                    this.subpackArr.map(function(subpack) {
                        subpack.resDirs.map(function(dir) {
                            HotUpdateBuilder.readDirToUUID(null, dir, subpack, self.mainPackNoGen, self.buildType, path.join(Editor.Project.path, self.packageSaveDir + "/" + subpack.name + "/"));
                            //HotUpdateBuilder._testDir(dir);
                        })
                    })
                },
                genManifest() {
                    var self = this;
                    this.subpackArr.map(function(subpack) {
                        var manifest = HotUpdateBuilder.generateManifest(self.packageUrl, subpack);
                        HotUpdateBuilder.writeManifest(self.packageSaveDir, manifest);
                    })
                },
                buildMainManifest() {
                    HotUpdateBuilder.readDirManifest(Editor.Project.path+"/build/"+this.buildType+"/" ,Editor.Project.path+"/build/"+this.buildType+"/res/",this.mainManifest.assets,this.mainPackNoGen,this.packageSaveDir,this.mainManifest.name);
                    HotUpdateBuilder.readDirManifest(Editor.Project.path+"/build/"+this.buildType+"/" ,Editor.Project.path+"/build/"+this.buildType+"/src/",this.mainManifest.assets,this.mainPackNoGen, this.packageSaveDir,this.mainManifest.name);
                },
                genMainManifest() {
                    var manifest = HotUpdateBuilder.generateManifest(this.packageUrl, this.mainManifest);
                    HotUpdateBuilder.writeManifest(this.packageSaveDir, manifest);
                },
                saveConfig() {
                    var toWrite = {
                        buildType: this.buildType,
                        packageSaveDir: this.packageSaveDir,
                        packageUrl: this.packageUrl,
                        mainManifest: this.mainManifest,
                        subpackArr: this.subpackArr
                    }
                    FsExtra.writeJSON(Editor.Project.path+"/settings/manifestsetting.json", toWrite, function (err) {
                        Editor.log("Ghi file save thành công");
                    });
                },
                readConfig() {
                    var self = this;
                    FsExtra.readJson(Editor.Project.path+"/settings/manifestsetting.json", function (err, saveData) {
                        self.buildType = saveData.buildType;
                        self.packageSaveDir = saveData.packageSaveDir;
                        self.packageUrl = saveData.packageUrl;
                        self.mainManifest = saveData.mainManifest;
                        self.subpackArr = saveData.subpackArr;
                        Editor.log(JSON.stringify(self.subpackArr));
                    });
                },
                genSearchPath(){
                    var search = [this.mainManifest.name];
                    this.subpackArr.forEach(element => {
                        search.push(element.name);
                    })
                    Editor.log(Editor.Project.path+"/"+this.packageSaveDir + "searchpath.json");
                    FsExtra.writeJSON(Editor.Project.path+"/"+this.packageSaveDir + "searchpath.json", search, function (err) {
                        Editor.log(err);
                    });
                }
            }


        });
    },
    messages: {
        'onBuildFinished'(event, strData) {
            plugConfig = {
                packageUrl: this.vue.packageUrl,
                subpackArr: this.vue.subpackArr,
                packageSaveDir: this.vue.packageSaveDir,
            }
            if (event.reply) {
                event.reply(null, JSON.stringify(plugConfig));
            }
        }
    }
});